VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   4260
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6120
   LinkTopic       =   "Form1"
   ScaleHeight     =   4260
   ScaleWidth      =   6120
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtAmount 
      Height          =   375
      Left            =   600
      TabIndex        =   5
      Top             =   2880
      Width           =   3735
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   600
      TabIndex        =   4
      Top             =   2280
      Width           =   1695
   End
   Begin VB.CommandButton cmdWithdraw 
      Caption         =   "Withdraw"
      Height          =   375
      Left            =   600
      TabIndex        =   3
      Top             =   1800
      Width           =   1695
   End
   Begin VB.CommandButton cmdDeposit 
      Caption         =   "Deposit"
      Height          =   375
      Left            =   600
      TabIndex        =   2
      Top             =   1320
      Width           =   1695
   End
   Begin VB.Label lblBalance 
      Caption         =   "Label1"
      Height          =   375
      Left            =   840
      TabIndex        =   1
      Top             =   720
      Width           =   3735
   End
   Begin VB.Label lblDesc 
      Caption         =   "Label1"
      Height          =   375
      Left            =   840
      TabIndex        =   0
      Top             =   120
      Width           =   3735
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_oBankAccount As SimpleBank.BankAccount

Private Sub Form_Load()
   '--- Create the Bank Account object
   Set m_oBankAccount = New SimpleBank.BankAccount
   '--- Enable the User Interface
   EnableUI
   '--- Update the User Interface
   UpdateUI
End Sub

Private Sub EnableUI()
   '--- Check to make sure the account is a client
   If Not m_oBankAccount.IsClient() Then
      '--- The account is not a client, disable the controls
      cmdDeposit.Enabled = False
      cmdWithdraw.Enabled = False
   End If
End Sub

Private Sub Form_Terminate()
   '--- Clean up
   Set m_oBankAccount = Nothing
End Sub

Private Sub cmdExit_Click()
   '--- Close the application
   Unload Me
End Sub

Private Sub cmdDeposit_Click()
Dim cAmount As Currency

   '--- Check to make sure that a number was entered by the user
   If IsNumeric(txtAmount.Text) Then
      '--- Convert the user input into currency
      cAmount = CCur(txtAmount.Text)
      '--- Call the Deposit method
      If m_oBankAccount.Deposit(cAmount) Then
         '--- Update the display
         UpdateUI
      Else
         '--- Error, tell the user
         ErrMsgBox "Deposit failed!"
      End If
   Else
      '--- The user didn't enter a number, tell them
      ErrMsgBox "Please enter a number!"
      '--- Put the focus on the amount text box
      txtAmount.SetFocus
      '--- Select all of the text in the box
      txtAmount.SelStart = 0
      txtAmount.SelLength = Len(txtAmount.Text)
   End If
End Sub

Private Sub cmdWithdraw_Click()
Dim cAmount As Currency

   '--- Check to make sure that a number was entered by the user
   If IsNumeric(txtAmount.Text) Then
      '--- Convert the user input into currency
      cAmount = CCur(txtAmount.Text)
      '--- Call the Withdraw method
      If m_oBankAccount.WithDdraw(cAmount) Then
         '--- Update the display
         UpdateUI
      Else
         '--- Error, tell the user
         ErrMsgBox "Withdraw failed!"
      End If
   Else
      '--- The user didn't enter a number, tell them
      ErrMsgBox "Please enter a number!"
      '--- Put the focus on the amount text box
      txtAmount.SetFocus
      '--- Select all of the text in the box
      txtAmount.SelStart = 0
      txtAmount.SelLength = Len(txtAmount.Text)
   End If
End Sub

Private Sub UpdateUI()
   '--- Update the balance display
   lblBalance.Caption = CStr(m_oBankAccount.Balance)
   '--- Refresh the screen
   Me.Refresh
End Sub

Private Sub ErrMsgBox(sMessage As String)
   '--- Display the error message for the user
   MsgBox sMessage, vbExclamation, "Error!"
End Sub

