VERSION 5.00
Begin VB.Form frmSign 
   Caption         =   "Digital Signatures"
   ClientHeight    =   6495
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6810
   LinkTopic       =   "Form1"
   ScaleHeight     =   6495
   ScaleWidth      =   6810
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtDecryptMsg 
      Height          =   1395
      Left            =   1200
      MultiLine       =   -1  'True
      TabIndex        =   14
      Top             =   4560
      Width           =   5535
   End
   Begin VB.CommandButton cmdVerify 
      Caption         =   "&Verify Sig"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4140
      TabIndex        =   11
      Top             =   4140
      Width           =   1215
   End
   Begin VB.CommandButton cmdDecode 
      Caption         =   "&Decrypt"
      Enabled         =   0   'False
      Height          =   375
      Left            =   5460
      TabIndex        =   12
      Top             =   4140
      Width           =   1215
   End
   Begin VB.TextBox txtSignedMsg 
      Height          =   1395
      Left            =   1200
      MultiLine       =   -1  'True
      TabIndex        =   10
      Top             =   2700
      Width           =   5535
   End
   Begin VB.CommandButton cmdSignMsg 
      Caption         =   "&Sign Message"
      Enabled         =   0   'False
      Height          =   375
      Left            =   4140
      TabIndex        =   7
      Top             =   2280
      Width           =   1215
   End
   Begin VB.CommandButton cmdSignEncr 
      Caption         =   "Sign && &Encrypt"
      Enabled         =   0   'False
      Height          =   375
      Left            =   5460
      TabIndex        =   8
      Top             =   2280
      Width           =   1215
   End
   Begin VB.TextBox txtMsg 
      Height          =   1395
      Left            =   1200
      MultiLine       =   -1  'True
      TabIndex        =   6
      Top             =   840
      Width           =   5535
   End
   Begin VB.ComboBox cboStore 
      Height          =   315
      ItemData        =   "frmSign.frx":0000
      Left            =   1200
      List            =   "frmSign.frx":0013
      TabIndex        =   3
      Top             =   480
      Width           =   3195
   End
   Begin VB.CommandButton cmdGetCert 
      Caption         =   "&Get Certificate"
      Height          =   375
      Left            =   5460
      TabIndex        =   4
      Top             =   420
      Width           =   1215
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   5460
      TabIndex        =   15
      Top             =   6060
      Width           =   1215
   End
   Begin VB.TextBox txtName 
      Height          =   375
      Left            =   1200
      TabIndex        =   1
      Top             =   60
      Width           =   4215
   End
   Begin VB.Label Label5 
      Caption         =   "Decrypted Msg:"
      Height          =   435
      Left            =   180
      TabIndex        =   13
      Top             =   4620
      Width           =   915
   End
   Begin VB.Label Label4 
      Caption         =   "Resulting Msg:"
      Height          =   435
      Left            =   180
      TabIndex        =   9
      Top             =   2760
      Width           =   915
   End
   Begin VB.Label Label3 
      Caption         =   "Message:"
      Height          =   315
      Left            =   180
      TabIndex        =   5
      Top             =   900
      Width           =   915
   End
   Begin VB.Label Label2 
      Caption         =   "Cert Store:"
      Height          =   315
      Left            =   180
      TabIndex        =   2
      Top             =   480
      Width           =   915
   End
   Begin VB.Label Label1 
      Caption         =   "Name:"
      Height          =   315
      Left            =   180
      TabIndex        =   0
      Top             =   60
      Width           =   915
   End
End
Attribute VB_Name = "frmSign"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private csCrypt As clsCrypto
Private m_sSignedMsg As String

Private Sub cmdDecode_Click()
    '--- Copy the signed and encrypted message to the
    '--- input buffer
    csCrypt.InBuffer = m_sSignedMsg
    '--- Decrypt the message and validate the signature
    If csCrypt.DecryptAndValidateMessage Then
        MsgBox "Signature valid."
        '--- Copy the extracted message to the display
        txtDecryptMsg.Text = csCrypt.OutBuffer
    Else
        MsgBox "Invalid Signature."
    End If
End Sub

Private Sub cmdExit_Click()
    '--- Do we have a crypto object?
    If Not (csCrypt Is Nothing) Then
        '--- Release the signature certificate
        csCrypt.ReleaseSignatureCertificate
        '--- Destroy the crypto object
        Set csCrypt = Nothing
    End If
    '--- Close the application
    Unload Me
End Sub

Private Sub cmdGetCert_Click()
    '--- Create the crypto object
    Set csCrypt = New clsCrypto
    '--- Get the signature certificate for the specified user
    If csCrypt.GetSignatureCertificate(cboStore, txtName) Then
        '--- Certificate found, enable the sign and encrypt buttons
        cmdSignMsg.Enabled = True
        cmdSignEncr.Enabled = True
    Else
        MsgBox "Unable to get certificate for " & txtName _
                & "Reason: &H" & Hex(Err.LastDllError)
    End If
End Sub

Private Sub cmdSignEncr_Click()
    '--- Copy the message text to the input buffer
    csCrypt.InBuffer = txtMsg.Text
    '--- Sign and encrypt the message
    If csCrypt.SignAndEncryptMessage(txtName) Then
        '--- The message was encrypted, copy and hold onto
        '--- the encrypted message
        m_sSignedMsg = csCrypt.OutBuffer
        '--- Display the encrypted message to the user
        txtSignedMsg.Text = csCrypt.OutBuffer
        '--- Enable the decrypt button
        cmdDecode.Enabled = True
        cmdVerify.Enabled = False
    End If
End Sub

Private Sub cmdSignMsg_Click()
    '--- Copy the message text to the input buffer
    csCrypt.InBuffer = txtMsg.Text
    '--- Sign the message
    If csCrypt.SignMessage Then
        '--- The message was signed, copy and hold onto
        '--- the signed message
        m_sSignedMsg = csCrypt.OutBuffer
        '--- Display the signed message blob to the user
        txtSignedMsg.Text = csCrypt.OutBuffer
        '--- Enable the verify button
        cmdVerify.Enabled = True
        cmdDecode.Enabled = False
    End If
End Sub

Private Sub cmdVerify_Click()
    '--- Copy the signed message to the input buffer
    csCrypt.InBuffer = m_sSignedMsg
    '--- Validate the signature
    If csCrypt.ValidateSignature Then
        MsgBox "Signature valid."
        '--- Copy the extracted message to the display
        txtDecryptMsg.Text = csCrypt.OutBuffer
    Else
        MsgBox "Invalid Signature."
    End If
End Sub

