VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "Comdlg32.OCX"
Begin VB.Form frmCRLCheck 
   Caption         =   "Certificate Verification"
   ClientHeight    =   6780
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6660
   LinkTopic       =   "Form1"
   ScaleHeight     =   6780
   ScaleWidth      =   6660
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdCreateCrlListCerts 
      Caption         =   "&Compare Certs to CRL"
      Height          =   315
      Left            =   1440
      TabIndex        =   12
      Top             =   6420
      Width           =   1935
   End
   Begin MSComDlg.CommonDialog cdFile 
      Left            =   6120
      Top             =   960
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox txtFileName 
      Height          =   315
      Left            =   1440
      TabIndex        =   8
      Top             =   6000
      Width           =   3495
   End
   Begin VB.CommandButton cmdBrowse 
      Caption         =   "&Browse"
      Height          =   315
      Left            =   5040
      TabIndex        =   9
      Top             =   6000
      Width           =   1575
   End
   Begin VB.CommandButton cmdGetCRL 
      Caption         =   "&Import CRL List"
      Height          =   315
      Left            =   3420
      TabIndex        =   10
      Top             =   6420
      Width           =   1575
   End
   Begin VB.TextBox txtServer 
      Height          =   375
      Left            =   2280
      TabIndex        =   1
      Top             =   120
      Width           =   3615
   End
   Begin VB.TextBox txtCA 
      Height          =   375
      Left            =   2280
      TabIndex        =   3
      Top             =   600
      Width           =   3615
   End
   Begin VB.TextBox txtCerts 
      Height          =   4395
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   1500
      Width           =   6555
   End
   Begin VB.ComboBox cboStore 
      Height          =   315
      ItemData        =   "frmCrlCheck.frx":0000
      Left            =   60
      List            =   "frmCrlCheck.frx":0013
      TabIndex        =   4
      Top             =   1080
      Width           =   3195
   End
   Begin VB.CommandButton cmdList 
      Caption         =   "&List Certificates"
      Height          =   315
      Left            =   3360
      TabIndex        =   5
      Top             =   1080
      Width           =   1575
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   315
      Left            =   5040
      TabIndex        =   11
      Top             =   6420
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "&CRL File:"
      Height          =   255
      Left            =   60
      TabIndex        =   7
      Top             =   6000
      Width           =   1275
   End
   Begin VB.Label Label7 
      Caption         =   "Ser&ver Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2055
   End
   Begin VB.Label Label8 
      Caption         =   "Certi&ficate Authority:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   2055
   End
End
Attribute VB_Name = "frmCRLCheck"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdBrowse_Click()
    cdFile.Filter = "CRL File|*.crl|All Files|*.*"
    cdFile.ShowOpen
    txtFileName.Text = cdFile.FileName
End Sub

Private Sub cmdCreateCrlListCerts_Click()
    Dim csCrypt As New clsCrypto
    
    csCrypt.Server = txtServer
    csCrypt.CertificateAuthority = txtCA
    txtCerts = csCrypt.CreateCRLAndCheckCerts(cboStore, txtFileName)
End Sub

Private Sub cmdExit_Click()
    '--- Exit the application
    Unload Me
End Sub

Private Sub cmdGetCRL_Click()
    Dim csCrypt As New clsCrypto
    
    csCrypt.Server = txtServer
    csCrypt.CertificateAuthority = txtCA
    csCrypt.GetCRLFromCA cboStore, txtFileName
    MsgBox "CRL Added to the Certificate Store."
End Sub

Private Sub cmdList_Click()
    Dim csCrypt As New clsCrypto
    
    csCrypt.Server = txtServer
    csCrypt.CertificateAuthority = txtCA
    '--- Retrieve and display the list of certificates
    txtCerts = csCrypt.ListCerts(cboStore)
End Sub

