VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form frmADObjects 
   Caption         =   "Active Directory Objects"
   ClientHeight    =   6660
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9120
   LinkTopic       =   "Form1"
   ScaleHeight     =   6660
   ScaleWidth      =   9120
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtPassword 
      Height          =   375
      IMEMode         =   3  'DISABLE
      Left            =   1680
      PasswordChar    =   "*"
      TabIndex        =   8
      Top             =   1080
      Width           =   4455
   End
   Begin VB.TextBox txtUsername 
      Height          =   375
      Left            =   1680
      TabIndex        =   6
      Top             =   600
      Width           =   4455
   End
   Begin VB.TextBox txtDomain 
      Height          =   375
      Left            =   1680
      TabIndex        =   4
      Top             =   120
      Width           =   4455
   End
   Begin VB.TextBox txtDetails 
      Height          =   5055
      Left            =   3720
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      Top             =   1560
      Width           =   5295
   End
   Begin MSComctlLib.TreeView tvNodes 
      Height          =   5055
      Left            =   120
      TabIndex        =   1
      Top             =   1560
      Width           =   3495
      _ExtentX        =   6165
      _ExtentY        =   8916
      _Version        =   393217
      Style           =   7
      Appearance      =   1
   End
   Begin VB.CommandButton cmdGetObjs 
      Caption         =   "Get Objects"
      Height          =   375
      Left            =   7440
      TabIndex        =   0
      Top             =   1080
      Width           =   1575
   End
   Begin VB.Label Label3 
      Caption         =   "Password:"
      Height          =   255
      Left            =   240
      TabIndex        =   7
      Top             =   1080
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "Username:"
      Height          =   255
      Left            =   240
      TabIndex        =   5
      Top             =   600
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "Domain:"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "frmADObjects"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'--- ADS_RIGHTS_ENUM
Const ADS_RIGHT_DELETE = &H10000
Const ADS_RIGHT_READ_CONTROL = &H20000
Const ADS_RIGHT_WRITE_DAC = &H40000
Const ADS_RIGHT_WRITE_OWNER = &H80000
Const ADS_RIGHT_SYNCHRONIZE = &H100000
Const ADS_RIGHT_ACCESS_SYSTEM_SECURITY = &H1000000
Const ADS_RIGHT_GENERIC_READ = &H80000000
Const ADS_RIGHT_GENERIC_WRITE = &H40000000
Const ADS_RIGHT_GENERIC_EXECUTE = &H20000000
Const ADS_RIGHT_GENERIC_ALL = &H10000000
Const ADS_RIGHT_DS_CREATE_CHILD = &H1
Const ADS_RIGHT_DS_DELETE_CHILD = &H2
Const ADS_RIGHT_ACTRL_DS_LIST = &H4
Const ADS_RIGHT_DS_SELF = &H8
Const ADS_RIGHT_DS_READ_PROP = &H10
Const ADS_RIGHT_DS_WRITE_PROP = &H20
Const ADS_RIGHT_DS_DELETE_TREE = &H40
Const ADS_RIGHT_DS_LIST_OBJECT = &H80
Const ADS_RIGHT_DS_CONTROL_ACCESS = &H100

'--- ADS_ACETYPE_ENUM
Const ADS_ACETYPE_ACCESS_ALLOWED = 0
Const ADS_ACETYPE_ACCESS_DENIED = &H1
Const ADS_ACETYPE_SYSTEM_AUDIT = &H2
Const ADS_ACETYPE_ACCESS_ALLOWED_OBJECT = &H5
Const ADS_ACETYPE_ACCESS_DENIED_OBJECT = &H6
Const ADS_ACETYPE_SYSTEM_AUDIT_OBJECT = &H7

'--- ADS_ACEFLAG_ENUM
Const ADS_ACEFLAG_INHERIT_ACE = &H2
Const ADS_ACEFLAG_NO_PROPAGATE_INHERIT_ACE = &H4
Const ADS_ACEFLAG_INHERIT_ONLY_ACE = &H8
Const ADS_ACEFLAG_INHERITED_ACE = &H10
Const ADS_ACEFLAG_VALID_INHERIT_FLAGS = &H1F
Const ADS_ACEFLAG_SUCCESSFUL_ACCESS = &H40
Const ADS_ACEFLAG_FAILED_ACCESS = &H80

'--- ADS_FLAGTYPE_ENUM
Const ADS_FLAG_OBJECT_TYPE_PRESENT = &H1
Const ADS_FLAG_INHERITED_OBJECT_TYPE_PRESENT = &H2

'--- ADS_AUTHENTICATION_ENUM
Const ADS_SECURE_AUTHENTICATION = &H1
Const ADS_USE_ENCRYPTION = &H2
Const ADS_USE_SSL = &H2
Const ADS_READONLY_SERVER = &H4
Const ADS_PROMPT_CREDENTIALS = &H8
Const ADS_NO_AUTHENTICATION = &H10
Const ADS_FAST_BIND = &H20
Const ADS_USE_SIGNING = &H40
Const ADS_USE_SEALING = &H80

Private Function GetSecurity(obj As IADs) As String
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetSecurity(obj)
'*
'* Parameters: obj As IADs
'*
'* Purpose: This function builds a string that describes the
'*          security descriptor of the object passed in. It
'*          specifies the owner and group of the object, and
'*          includes all the entries in the object's Access
'*          Control List.
'*************************************************************
    Dim objSecur As SecurityDescriptor
    Dim objDacl As AccessControlList
    Dim objDace As AccessControlEntry
    Dim strRtn As String
    Dim lAccMask As Long
    
    '--- Get the Security Descriptor for the object passed in
    Set objSecur = obj.Get("ntSecurityDescriptor")
    '--- Initialize the return string
    strRtn = vbCrLf + "Security:" + vbCrLf
    '--- Add the owner to the return string
    strRtn = strRtn + vbTab + "Owner: " + objSecur.Owner + vbCrLf
    '--- Add the group to the return string
    strRtn = strRtn + vbTab + "Group: " + objSecur.Group + vbCrLf
    '--- Get the Access Control List from the Security Descriptor
    Set objDacl = objSecur.DiscretionaryAcl
    '--- Get the number of Access Control Entries in the Access Control List
    strRtn = strRtn + vbTab + "ACE Count: " + CStr(objDacl.AceCount) + vbCrLf
    '--- Loop through the Access Control Entries
    For Each objDace In objDacl
        '--- Add the ACE Trustee to the return string
        strRtn = strRtn + vbTab + "Trustee: " + objDace.Trustee + vbCrLf
        '--- Add the access rights to the return string
        strRtn = strRtn + vbTab + vbTab + "Access Rights: " + vbCrLf
        strRtn = strRtn + GetAccessRights(objDace.AccessMask)
        '--- Add the Ace Flags to the return string
        If (objDace.AceFlags > 0) Then
            strRtn = strRtn + vbTab + vbTab + "Ace Flags: " + vbCrLf
            strRtn = strRtn + GetAccessFlags(objDace.AceFlags)
        End If
        '--- Add the Ace Type to the return string
        strRtn = strRtn + vbTab + vbTab + "Ace Type: " + _
            GetAccessType(objDace.AceType)
        '--- If there is an object type included, add it to the return string
        If ((objDace.Flags And ADS_FLAG_OBJECT_TYPE_PRESENT) > 0) Then _
            strRtn = strRtn + vbTab + vbTab + "Object Type: " + _
                objDace.ObjectType + vbCrLf
        '--- If there is an inherited object type included, add it
        '--- to the return string
        If ((objDace.Flags And ADS_FLAG_INHERITED_OBJECT_TYPE_PRESENT) > 0) _
            Then strRtn = strRtn + vbTab + vbTab + "Inherited Object Type: " _
                + objDace.InheritedObjectType + vbCrLf
    Next
    '--- Return the security descriptor string
    GetSecurity = strRtn
End Function

Private Sub GetNamespaces()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetNamespaces
'*
'* Parameters: None
'*
'* Purpose: This subroutine builds a list of all the names
'*          in the ADS name space.
'*************************************************************
    Dim objNameSpaces As Object
    Dim nsSpaces As Object
    Dim dmDomain As Object
    Dim strMsg As String
    
    On Error Resume Next
    '--- Get the root object for the name spaces
    Set objNameSpaces = GetObject("ADs:")
    '--- Initialize the display string
    strMsg = ""
    '--- Loop through all the names in the name spaces
    For Each nsSpaces In objNameSpaces
        '--- Add the name to the list
        strMsg = strMsg + nsSpaces.Name + vbCrLf
        '--- Loop through the domains in the current name space
        For Each dmDomain In nsSpaces
            '--- Make sure that no error occurred
            If Err.Number = 0 Then
                '--- Add the domain name to the list
                strMsg = strMsg + vbTab + dmDomain.Name + vbCrLf
                '--- Get and display the domain information
                GetDomain dmDomain.Name
            End If
        Next
    Next
    '--- Display the information for the user
    MsgBox strMsg
End Sub

Private Sub GetDomain(strDomain As String)
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetDomain(strDomain)
'*
'* Parameters: strDomain As String
'*
'* Purpose: This subroutine creates a list of the properties
'*          of the schema for the domain passed in.
'*************************************************************
    Dim objDomain As Object
    Dim objSchema As IADsClass
    Dim objMem As Object
    Dim strMsg As String
    Dim strDmn As String
    
'    On Error Resume Next
    '--- Build the string to retrieve the domain information
    strDmn = "WinNT://" + strDomain
    '--- Get the domain
    Set objDomain = GetObject(strDmn)
    '--- Get the domain's schema
    Set objSchema = GetObject(objDomain.Schema)
    '--- Initialize the information string
    strMsg = ""
    '--- Add the ADS path to the string
    strMsg = "ADS Path: " + objSchema.ADsPath + vbCrLf
    '--- Add the class to the string
    strMsg = strMsg + "Class: " + objSchema.Class + vbCrLf
    '--- Add the schema ID to the string
    strMsg = strMsg + "Schema: " + objSchema.CLSID + vbCrLf
    '--- Does the schema contain objects?
    If objSchema.Container Then
        '--- Add a header for the list of things contained in the schema
        strMsg = strMsg + "Contains:" + vbCrLf
        '--- Loop through the objects
        For Each objMem In objSchema.Containment
            '--- Add the object name to the list
            strMsg = strMsg + vbTab + objMem.Name + vbCrLf
        Next
    End If
    '--- State what the domain was derived from
    strMsg = strMsg + "Derived From: " + objSchema.DerivedFrom + vbCrLf
    '--- Add the GUID
    strMsg = strMsg + "GUID: " + objSchema.Guid + vbCrLf
    '--- Add any manditory properties
    strMsg = strMsg + "Mandatory Properties:" + vbCrLf
    '--- Loop through the manditory properties
    For Each objMem In objSchema.MandatoryProperties
        '--- Add the property name to the list
        strMsg = strMsg + vbTab + objMem.Name + vbCrLf
    Next
    '--- Add the schema name
    strMsg = strMsg + "Name: " + objSchema.Name + vbCrLf
    '--- Add any optional properties
    strMsg = strMsg + "Optional Properties:" + vbCrLf
    '--- Loop through the optional properties
    For Each objMem In objSchema.OptionalProperties
        '--- Add the property name to the list
        strMsg = strMsg + vbTab + objMem.Name + vbCrLf
    Next
    '--- Add the schema to the list
    strMsg = strMsg + "Schema: " + objSchema.Schema
    '--- Display the list of schema properties for the user
    MsgBox strMsg
    '--- Clean up
    Set objSchema = Nothing
End Sub

Private Sub GetUnits()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetUnits
'*
'* Parameters: None
'*
'* Purpose: This subroutine opens a security context to the
'*          root of the domain specified by the user. It uses
'*          this as the starting point for the tree view of
'*          the domain.
'*************************************************************
    Dim openDS As IADsOpenDSObject
    Dim obj As IADs
    Dim strName As String
    Dim ndNewNode As Node
    Dim strDomain As String
    Dim lDotPos As Long
    Dim lLastDotPos As Long
    Dim strOrgDomain As String
    Dim lStringLen As Long
    
    '--- Build the object LDAP name for the domain
    If (InStr(1, txtDomain, ".", vbTextCompare) > 0) Then
        strOrgDomain = txtDomain
        '---Cache the length of the dot domain string
        lStringLen = Len(strOrgDomain)
        
        '---Loop through the string, extracting each sub-domain
        '---and finally the top domain
        Do
            '--- Get the position of the next . in the string
            lDotPos = InStr(lLastDotPos + 1, strOrgDomain, ".")
            '--- If there are no more dots, set the dot position to the string length plus 1
            If lDotPos = 0 Then lDotPos = lStringLen + 1
            '--- If there is already text in the LDAP string, we know we need a comma separator
            If Len(strDomain) > 0 Then strDomain = strDomain & ","
            '--- Append the domain element to the LDAP domain path
            strDomain = strDomain & "DC=" & Mid$(strOrgDomain, lLastDotPos + 1, lDotPos - lLastDotPos - 1)
            '---Remember our position in the string
            lLastDotPos = lDotPos
        Loop While lDotPos < lStringLen
        strDomain = "LDAP://" & strDomain
    Else
        strDomain = "LDAP://" + txtDomain
    End If
    '--- Open the LDAP interface
    Set openDS = GetObject("LDAP:")
    '--- Open the security context using secure authentication
    Set obj = openDS.OpenDSObject(strDomain, _
                    txtUsername, txtPassword, ADS_SECURE_AUTHENTICATION)
    '--- Strip the unneeded portion from the domain name
    strName = obj.Name
    If (InStr(1, strName, "=", vbTextCompare) > 0) Then
        strName = Mid(strName, (InStr(1, strName, "=", vbTextCompare) + 1))
    End If
    '--- Clear the tree from any previous objects
    tvNodes.Nodes.Clear
    '--- Add the domain name as the root node in the tree view
    Set ndNewNode = tvNodes.Nodes.Add(, , obj.ADsPath, strName)
    '--- Add all of the children node to the tree view
    ListChildren obj
    '--- Clean up
    Set openDS = Nothing
End Sub

Private Sub ListChildren(obj As IADs)
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     ListChildren(obj)
'*
'* Parameters: obj As IADs
'*
'* Purpose: This subroutine recursively adds all the children
'*          nodes to the tree view.
'*************************************************************
    Dim objCont As IADsContainer
    Dim objChild As IADs
    Dim strName As String
    Dim strParent As String
    Dim ndNewNode As Node
    
    '--- Hold onto the name of the parent node
    strParent = obj.ADsPath
    '--- Get the IADsContainer interface for the object passed in
    Set objCont = obj
    '--- If an error occurred, then there are no children
    If Err = 0 Then
        '--- Loop through all the children of the current node
        For Each objChild In objCont
            '--- Get the child's name and strip off the prefix
            strName = objChild.Name
            If (InStr(1, strName, "=", vbTextCompare) > 0) Then
                strName = Mid(strName, (InStr(1, strName, "=", _
                    vbTextCompare) + 1))
            End If
            '--- Add the child as a new node to the tree view
            Set ndNewNode = tvNodes.Nodes.Add(strParent, tvwChild, _
                objChild.ADsPath, strName)
            '--- Add all the children node to the tree view
            ListChildren objChild
        Next
    End If
End Sub

Private Sub cmdGetObjs_Click()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     cmdGetObjs_Click
'*
'* Parameters: None
'*
'* Purpose: This subroutine loads the tree view control with
'*          the ADS objects in the domain specified by the user.
'*************************************************************
'    GetNamespaces
    '--- Load the tree view control
    GetUnits
End Sub

Private Sub tvNodes_Click()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     tvNodes_Click
'*
'* Parameters: None
'*
'* Purpose: This subroutine gets the details of the selected
'*          node in the tree view control.
'*************************************************************
    Dim ndItem As Node
    Dim strADS As String

    '--- Get the selected node
    Set ndItem = tvNodes.SelectedItem
    '--- Get the key of the selected node
    strADS = ndItem.Key
    '--- Get the details of the selected node
    GetDetails strADS
End Sub

Private Sub GetDetails(strPath As String)
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetDetails(strPath)
'*
'* Parameters: strPath As String
'*
'* Purpose: This subroutine retrieves the specified object
'*          using the LDAP interface, determines the class of
'*          the object, and then calls the appropriate method to
'*          display the details of the object.
'*************************************************************
    Dim openDS As IADsOpenDSObject
    Dim obj As IADs
    
    '--- Open the LDAP interface
    Set openDS = GetObject("LDAP:")
    '--- Open the security context using secure authentication
    Set obj = openDS.OpenDSObject(strPath, _
                    txtUsername, txtPassword, ADS_SECURE_AUTHENTICATION)
    '--- Determine the class of the object and call the appropriate
    '--- method to display the details of the object
    Select Case obj.Class
        '--- The object is a user
        Case "user"
            GetUserDetails obj
        '--- The object is a group
        Case "group"
            GetGroupDetails obj
        '--- The object is a contact
        Case "contact"
            GetUserDetails obj
        '--- The object is an organizational unit
        Case "organizationalUnit"
            GetOrganizationalUnit obj
        '--- The object is a container
        Case "container"
            GetContainerDetails obj
        '--- The object is a miscellaneous object
        Case Else
            GetObjDetails obj
    End Select
End Sub

Private Sub GetUserDetails(obj As IADs)
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetUserDetails(obj)
'*
'* Parameters: obj As IADs
'*
'* Purpose: This method extracts and formats all the details
'*          about the user object that is passed in.
'*************************************************************
    Dim objUser As IADsUser
    Dim strMsg As String
    Dim strName As String
    
    On Error Resume Next
    '--- Get the IADsUser interface for the object
    Set objUser = obj
    '--- Extract the object name from the name string
    strName = objUser.Name
    If (InStr(1, strName, "=", vbTextCompare) > 0) Then
        strName = Mid(strName, (InStr(1, strName, "=", vbTextCompare) + 1))
    End If
    '--- Specify the object type
    strMsg = "Object Type: " + objUser.Class + vbCrLf
    '--- Specify the user's name
    strMsg = strMsg + "Name: " + strName + vbCrLf
    '--- Specify the user's full name
    strMsg = strMsg + "Full Name: " + objUser.FullName + vbCrLf
    '--- Specify the user's description
    strMsg = strMsg + "Description: " + objUser.Description + vbCrLf
    '--- Specify the user's department
    strMsg = strMsg + "Department: " + objUser.Department + vbCrLf
    '--- Specify the user's division
    strMsg = strMsg + "Division: " + objUser.Division + vbCrLf
    '--- Specify the user's email address
    strMsg = strMsg + "EMail Address: " + objUser.EmailAddress + vbCrLf
    '--- Specify the user's home directory
    strMsg = strMsg + "Home Directory: " + objUser.HomeDirectory + vbCrLf
    '--- Specify the user's manager
    strMsg = strMsg + "Manager: " + objUser.Manager + vbCrLf
    '--- Specify the user's password expiration date
    strMsg = strMsg + "Password Expires: " + _
            CStr(objUser.PasswordExpirationDate) + vbCrLf
    '--- Specify the user's account expiration date
    strMsg = strMsg + "Account Expires: " + _
            CStr(objUser.AccountExpirationDate) + vbCrLf
    '--- Specify the object's security descriptor
    strMsg = strMsg + GetSecurity(objUser)
    '--- Display the user details
    txtDetails = strMsg
End Sub


Private Sub GetGroupDetails(obj As IADs)
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetGroupDetails(obj)
'*
'* Parameters: obj As IADs
'*
'* Purpose: This method extracts and formats all the details
'*          about the group object that is passed in.
'*************************************************************
    Dim objGroup As IADsGroup
    Dim strMsg As String
    Dim strName As String
    Dim objMem As IADsMembers
    Dim objM As Object
    
    '--- Get the IADsGroup interface for the object
    Set objGroup = obj
    '--- Extract the object name from the name string
    strName = objGroup.Name
    If (InStr(1, strName, "=", vbTextCompare) > 0) Then
        strName = Mid(strName, (InStr(1, strName, "=", vbTextCompare) + 1))
    End If
    '--- Specify the object type
    strMsg = "Object Type: " + objGroup.Class + vbCrLf
    '--- Specify the object's name
    strMsg = strMsg + "Name: " + strName + vbCrLf
    '--- Specify the object's description
    strMsg = strMsg + "Description: " + objGroup.Description + vbCrLf
    '--- Get the IADsMembers interface for the object
    Set objMem = objGroup.Members
    '--- Get the number of members in the group
    If objMem.Count > 0 Then
        '--- If there are members, list them
        strMsg = strMsg + "Members:" + vbCrLf
        '--- Loop through all the members in the group
        For Each objM In objMem
            '--- Extract the member name from the name string
            strName = objM.Name
            If (InStr(1, strName, "=", vbTextCompare) > 0) Then
                strName = Mid(strName, (InStr(1, strName, "=", _
                        vbTextCompare) + 1))
            End If
            '--- Specify the member's name
            strMsg = strMsg + vbTab + strName + vbCrLf
        Next
    End If
    '--- Specify the object's security descriptor
    strMsg = strMsg + GetSecurity(objGroup)
    '--- Display the user details
    txtDetails = strMsg
End Sub

Private Sub GetOrganizationalUnit(obj As IADs)
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetOrganizationalUnit(obj)
'*
'* Parameters: obj As IADs
'*
'* Purpose: This method extracts and formats all the details
'*          about the organizational unit object that is passed in.
'*************************************************************
    Dim objGroup As IADsOU
    Dim strMsg As String
    Dim strName As String
    Dim objMem As IADsMembers
    Dim objM As Object
    
    On Error Resume Next
    '--- Get the IADsOU interface for the object
    Set objGroup = obj
    '--- Extract the object name from the name string
    strName = objGroup.Name
    If (InStr(1, strName, "=", vbTextCompare) > 0) Then
        strName = Mid(strName, (InStr(1, strName, "=", vbTextCompare) + 1))
    End If
    '--- Specify the object type
    strMsg = "Object Type: " + objGroup.Class + vbCrLf
    '--- Specify the object's name
    strMsg = strMsg + "Name: " + strName + vbCrLf
    '--- Specify the object's description
    strMsg = strMsg + "Description: " + objGroup.Description + vbCrLf
    '--- Specify the business category
    strMsg = strMsg + "Business Category: " + _
            objGroup.BusinessCategory + vbCrLf
    '--- Specify the postal address
    strMsg = strMsg + "Postal Address: " + objGroup.PostalAddress + vbCrLf
    '--- Specify the locality
    strMsg = strMsg + "Locality: " + objGroup.LocalityName + vbCrLf
    '--- Specify the phone number
    strMsg = strMsg + "Phone: " + objGroup.TelephoneNumber + vbCrLf
    '--- Specify the see also
    strMsg = strMsg + "See Also: " + objGroup.SeeAlso + vbCrLf
    '--- Get the organizational units members
    strMsg = strMsg + GetContainerMembers(obj)
    '--- Specify the object's security descriptor
    strMsg = strMsg + GetSecurity(objGroup)
    '--- Display the user details
    txtDetails = strMsg
End Sub

Private Sub GetObjDetails(obj As IADs)
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetObjDetails(obj)
'*
'* Parameters: obj As IADs
'*
'* Purpose: This method extracts and formats all the details
'*          about the object that is passed in.
'*************************************************************
    Dim strMsg As String
    Dim strName As String

    '--- Extract the object name from the name string
    strName = obj.Name
    If (InStr(1, strName, "=", vbTextCompare) > 0) Then
        strName = Mid(strName, (InStr(1, strName, "=", vbTextCompare) + 1))
    End If
    '--- Specify the object type
    strMsg = "Object Type: " + obj.Class + vbCrLf
    '--- Specify the object's name
    strMsg = strMsg + "Name: " + strName + vbCrLf
    '--- Get the schema properties
    strMsg = strMsg + GetSchemaAttribs(obj)
    '--- Specify the object's security descriptor
    strMsg = strMsg + GetSecurity(obj)
    '--- Display the user details
    txtDetails = strMsg
End Sub

Private Function GetContainerMembers(obj As IADs) As String
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetContainerMembers(obj)
'*
'* Parameters: obj As IADs
'*
'* Purpose: This method extracts and formats the names of the
'*          objects in the container object that is passed in.
'*************************************************************
    Dim objGroup As IADsContainer
    Dim strMsg As String
    Dim strName As String
    Dim objMem As Object

    '--- Get the IADsContainer interface for the object
    Set objGroup = obj
    '--- Initialize the return string
    strMsg = ""
    '--- There are members
    strMsg = "Members:" + vbCrLf
    '--- Loop through each member in the container
    For Each objMem In objGroup
        '--- Extract the object name from the name string
        strName = objMem.Name
        If (InStr(1, strName, "=", vbTextCompare) > 0) Then
            strName = Mid(strName, (InStr(1, strName, "=", _
                    vbTextCompare) + 1))
        End If
        '--- Specify the object's name
        strMsg = strMsg + vbTab + strName + vbCrLf
    Next
    '--- Return the list of members
    GetContainerMembers = strMsg
End Function

Private Sub GetContainerDetails(obj As IADs)
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetContainerDetails(obj)
'*
'* Parameters: obj As IADs
'*
'* Purpose: This method extracts and formats all the details
'*          about the container object that is passed in.
'*************************************************************
    Dim objGroup As IADsContainer
    Dim strMsg As String
    Dim strName As String
    Dim objMem As Object

    '--- Get the IADsContainer interface for the object
    Set objGroup = obj
    strMsg = ""
    '--- Extract the object name from the name string
    strName = obj.Name
    If (InStr(1, strName, "=", vbTextCompare) > 0) Then
        strName = Mid(strName, (InStr(1, strName, "=", vbTextCompare) + 1))
    End If
    '--- Specify the object type
    strMsg = "Object Type: " + obj.Class + vbCrLf
    '--- Specify the object's name
    strMsg = strMsg + "Name: " + strName + vbCrLf
    '--- Specify the container's hints
    strMsg = strMsg + "Hints: " + objGroup.Hints + vbCrLf
    '--- Get the container's members
    strMsg = strMsg + GetContainerMembers(obj)
    '--- Specify the object's security descriptor
    strMsg = strMsg + GetSecurity(obj)
    '--- Display the user details
    txtDetails = strMsg
End Sub

Private Function GetAccessRights(lAccMask As Long) As String
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetAccessRights(lAccMask)
'*
'* Parameters: lAccMask As Long
'*
'* Purpose: This function builds a list of the access rights
'*          that are included in an Access Control Entry.
'*************************************************************
    Dim strRtn As String
    
    '--- Initialize the return string
    strRtn = ""
    '--- Is the ADS_RIGHT_DELETE right included?
    If ((lAccMask And ADS_RIGHT_DELETE) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "Delete" + vbCrLf
    '--- Is the ADS_RIGHT_READ_CONTROL right included?
    If ((lAccMask And ADS_RIGHT_READ_CONTROL) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Read Security Descriptor" + vbCrLf
    '--- Is the ADS_RIGHT_WRITE_DAC right included?
    If ((lAccMask And ADS_RIGHT_WRITE_DAC) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "Modify ACL" + vbCrLf
    '--- Is the ADS_RIGHT_WRITE_OWNER right included?
    If ((lAccMask And ADS_RIGHT_WRITE_OWNER) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "Assume Ownership" + vbCrLf
    '--- Is the ADS_RIGHT_SYNCHRONIZE right included?
    If ((lAccMask And ADS_RIGHT_SYNCHRONIZE) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Use for Synchronization" + vbCrLf
    '--- Is the ADS_RIGHT_ACCESS_SYSTEM_SECURITY right included?
    If ((lAccMask And ADS_RIGHT_ACCESS_SYSTEM_SECURITY) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Can Get or Set System ACL" + vbCrLf
    '--- Is the ADS_RIGHT_GENERIC_READ right included?
    If ((lAccMask And ADS_RIGHT_GENERIC_READ) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "Read" + vbCrLf
    '--- Is the ADS_RIGHT_GENERIC_WRITE right included?
    If ((lAccMask And ADS_RIGHT_GENERIC_WRITE) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "Write" + vbCrLf
    '--- Is the ADS_RIGHT_GENERIC_EXECUTE right included?
    If ((lAccMask And ADS_RIGHT_GENERIC_EXECUTE) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "List Children" + vbCrLf
    '--- Is the ADS_RIGHT_GENERIC_ALL right included?
    If ((lAccMask And ADS_RIGHT_GENERIC_ALL) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "All" + vbCrLf
    '--- Is the ADS_RIGHT_DS_CREATE_CHILD right included?
    If ((lAccMask And ADS_RIGHT_DS_CREATE_CHILD) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "Create Children" + vbCrLf
    '--- Is the ADS_RIGHT_DS_DELETE_CHILD right included?
    If ((lAccMask And ADS_RIGHT_DS_DELETE_CHILD) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "Delete Children" + vbCrLf
    '--- Is the ADS_RIGHT_ACTRL_DS_LIST right included?
    If ((lAccMask And ADS_RIGHT_ACTRL_DS_LIST) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "List Children" + vbCrLf
    '--- Is the ADS_RIGHT_DS_SELF right included?
    If ((lAccMask And ADS_RIGHT_DS_SELF) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Modify Group Membership" + vbCrLf
    '--- Is the ADS_RIGHT_DS_READ_PROP right included?
    If ((lAccMask And ADS_RIGHT_DS_READ_PROP) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "Read Properties" + vbCrLf
    '--- Is the ADS_RIGHT_DS_WRITE_PROP right included?
    If ((lAccMask And ADS_RIGHT_DS_WRITE_PROP) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "Write Properties" + vbCrLf
    '--- Is the ADS_RIGHT_DS_DELETE_TREE right included?
    If ((lAccMask And ADS_RIGHT_DS_DELETE_TREE) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Delete All Children" + vbCrLf
    '--- Is the ADS_RIGHT_DS_LIST_OBJECT right included?
    If ((lAccMask And ADS_RIGHT_DS_LIST_OBJECT) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + "List Object" + vbCrLf
    '--- Is the ADS_RIGHT_DS_CONTROL_ACCESS right included?
    If ((lAccMask And ADS_RIGHT_DS_CONTROL_ACCESS) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Extended Access Rights" + vbCrLf
    '--- Return the rights list
    GetAccessRights = strRtn
End Function

Private Function GetAccessType(lAceType As Long) As String
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetAccessType(lAceType)
'*
'* Parameters: lAceType As Long
'*
'* Purpose: This function builds a list of the access type
'*          of an Access Control Entry.
'*************************************************************
    Dim strRtn As String
    
    '--- Initialize the return string
    strRtn = ""
    '--- Determine which type of ACE this is
    Select Case lAceType
        Case ADS_ACETYPE_ACCESS_ALLOWED
            strRtn = "Access Allowed" + vbCrLf
        Case ADS_ACETYPE_ACCESS_DENIED
            strRtn = "Access Denied" + vbCrLf
        Case ADS_ACETYPE_SYSTEM_AUDIT
            strRtn = "Standard Access" + vbCrLf
        Case ADS_ACETYPE_ACCESS_ALLOWED_OBJECT
            strRtn = "Access Allowed" + vbCrLf
        Case ADS_ACETYPE_ACCESS_DENIED_OBJECT
            strRtn = "Access Denied" + vbCrLf
        Case ADS_ACETYPE_SYSTEM_AUDIT_OBJECT
            strRtn = "Standard Access" + vbCrLf
    End Select
    '--- Return the access type
    GetAccessType = strRtn
End Function

Private Function GetAccessFlags(lAccFlag As Long) As String
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetAccessFlags(lAccFlag)
'*
'* Parameters: lAccFlag As Long
'*
'* Purpose: This function builds a list of the access flags
'*          that are included in an Access Control Entry.
'*************************************************************
    Dim strRtn As String
    
    '--- Initialize the return string
    strRtn = ""
    '--- Is the ADS_ACEFLAG_INHERIT_ACE flag included?
    If ((lAccFlag And ADS_ACEFLAG_INHERIT_ACE) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Children will inherit ACE" + vbCrLf
    '--- Is the ADS_ACEFLAG_NO_PROPAGATE_INHERIT_ACE flag included?
    If ((lAccFlag And ADS_ACEFLAG_NO_PROPAGATE_INHERIT_ACE) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "ACE will not be inherited by children's children" + vbCrLf
    '--- Is the ADS_ACEFLAG_INHERIT_ONLY_ACE flag included?
    If ((lAccFlag And ADS_ACEFLAG_INHERIT_ONLY_ACE) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "ACE applies only to children" + vbCrLf
    '--- Is the ADS_ACEFLAG_INHERITED_ACE flag included?
    If ((lAccFlag And ADS_ACEFLAG_INHERITED_ACE) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "ACE was inherited" + vbCrLf
    '--- Is the ADS_ACEFLAG_VALID_INHERIT_FLAGS flag included?
    If ((lAccFlag And ADS_ACEFLAG_VALID_INHERIT_FLAGS) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Inherit flags are valid" + vbCrLf
    '--- Is the ADS_ACEFLAG_SUCCESSFUL_ACCESS flag included?
    If ((lAccFlag And ADS_ACEFLAG_SUCCESSFUL_ACCESS) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Generates audit messages for successful access" + vbCrLf
    '--- Is the ADS_ACEFLAG_FAILED_ACCESS flag included?
    If ((lAccFlag And ADS_ACEFLAG_FAILED_ACCESS) > 0) Then _
        strRtn = strRtn + vbTab + vbTab + vbTab + _
            "Generates audit messages for failed access" + vbCrLf
    '--- Return the flags list
    GetAccessFlags = strRtn
End Function

Private Function GetSchemaAttribs(obj As IADs) As String
'*************************************************************
'* Written By: Davis Chapman
'* Date:       February 12, 2000
'*
'* Syntax:     GetSchemaAttribs(obj)
'*
'* Parameters: obj As IADs
'*
'* Purpose: This function gets the object's schema and loops
'*          through the lists of mandatory and optional
'*          properties to add to the displayed list.
'*************************************************************
    Dim objSchema As IADsClass
    Dim objMem As Object
    Dim strMsg As String
    Dim lTotalNbr As Long
    Dim lCurNbr As Long
    
    On Error Resume Next
    '--- Get the object's schema
    Set objSchema = GetObject(obj.Schema)
    '--- Get the number of mandatory properties
    lTotalNbr = UBound(objSchema.MandatoryProperties)
    '--- Initialize the return string
    strMsg = "Mandatory Properties" + vbCrLf
    '--- Loop through the mandatory properties
    For lCurNbr = 0 To lTotalNbr
        '--- Add the property to the return string
        strMsg = strMsg & vbTab & objSchema.MandatoryProperties(lCurNbr) & ": " & obj.Get(objSchema.MandatoryProperties(lCurNbr)) & vbCrLf
    Next
    '--- Get the number of optional properties
    lTotalNbr = UBound(objSchema.OptionalProperties)
    '--- Add the section header to the return string
    strMsg = strMsg + "Optional Properties" + vbCrLf
    '--- Loop through the optional properties
    For lCurNbr = 0 To lTotalNbr
        '--- Add the property to the return string
        strMsg = strMsg & vbTab & objSchema.OptionalProperties(lCurNbr) & ": " & obj.Get(objSchema.OptionalProperties(lCurNbr)) & vbCrLf
    Next
    '--- Return the schema properties
    GetSchemaAttribs = strMsg
End Function

Public Function DotDomainToLDAP(ByVal sDotDomain As String) As String
    Dim lDotPos As Long
    Dim lLastDotPos As Long
    Dim sLDAPDomain As String
    Dim lStringLen As Long
    
    '---Cache the length of the dot domain string
    lStringLen = Len(sDotDomain)
    
    '---Loop through the string, extracting each sub-domain
    '---and finally the top domain
    Do
        '--- Get the position of the next . in the string
        lDotPos = InStr(lLastDotPos + 1, sDotDomain, ".")
        '--- If there are no more dots, set the dot position to the string length plus 1
        If lDotPos = 0 Then lDotPos = lStringLen + 1
        '--- If there is already text in the LDAP string, we know we need a comma separator
        If Len(sLDAPDomain) > 0 Then sLDAPDomain = sLDAPDomain & ","
        '--- Append the domain element to the LDAP domain path
        sLDAPDomain = sLDAPDomain & "DC=" & Mid$(sDotDomain, lLastDotPos + 1, lDotPos - lLastDotPos - 1)
        '---Remember our position in the string
        lLastDotPos = lDotPos
     Loop While lDotPos < lStringLen
    DotDomainToLDAP = "LDAP://" & sLDAPDomain
End Function

