VERSION 5.00
Object = "{248DD890-BB45-11CF-9ABC-0080C7E7B78D}#1.0#0"; "MSWINSCK.OCX"
Begin VB.Form frmKeys 
   Caption         =   "Public/Private Keys"
   ClientHeight    =   4590
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6990
   LinkTopic       =   "Form1"
   ScaleHeight     =   4590
   ScaleWidth      =   6990
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   315
      Left            =   5100
      TabIndex        =   21
      Top             =   4200
      Width           =   1755
   End
   Begin VB.TextBox txtRecvdData 
      Height          =   315
      Left            =   1500
      TabIndex        =   20
      TabStop         =   0   'False
      Top             =   1680
      Width           =   5355
   End
   Begin VB.CommandButton cmdSendMsg 
      Caption         =   "Sen&d Message"
      Enabled         =   0   'False
      Height          =   315
      Left            =   1500
      TabIndex        =   18
      Top             =   4200
      Width           =   3495
   End
   Begin VB.CommandButton cmdImportSessionKey 
      Caption         =   "&Import Session Key"
      Enabled         =   0   'False
      Height          =   315
      Left            =   1500
      TabIndex        =   17
      Top             =   3780
      Width           =   3495
   End
   Begin VB.CommandButton cmdImportPublicKey 
      Caption         =   "I&mport Public Key and Generate Session Key"
      Enabled         =   0   'False
      Height          =   315
      Left            =   1500
      TabIndex        =   16
      Top             =   3360
      Width           =   3495
   End
   Begin VB.CommandButton cmdGenKeys 
      Caption         =   "&Generate and Export Keys"
      Height          =   315
      Left            =   1500
      TabIndex        =   15
      Top             =   2940
      Width           =   3495
   End
   Begin VB.TextBox txtDecryptMsg 
      Height          =   315
      Left            =   1500
      TabIndex        =   14
      TabStop         =   0   'False
      Top             =   2520
      Width           =   5355
   End
   Begin VB.TextBox txtEncryptMsg 
      Height          =   315
      Left            =   1500
      TabIndex        =   12
      TabStop         =   0   'False
      Top             =   2100
      Width           =   5355
   End
   Begin VB.TextBox txtMessage 
      Height          =   315
      Left            =   1500
      TabIndex        =   10
      Text            =   "Type a message to send here."
      Top             =   1260
      Width           =   5355
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "&Close"
      Enabled         =   0   'False
      Height          =   315
      Left            =   5640
      TabIndex        =   8
      Top             =   600
      Width           =   1215
   End
   Begin VB.CommandButton cmdListen 
      Caption         =   "&Listen"
      Height          =   315
      Left            =   4320
      TabIndex        =   7
      Top             =   600
      Width           =   1215
   End
   Begin VB.TextBox txtPort 
      Height          =   315
      Left            =   3240
      TabIndex        =   6
      Top             =   600
      Width           =   975
   End
   Begin VB.TextBox txtServerName 
      Height          =   315
      Left            =   3240
      TabIndex        =   4
      Top             =   180
      Width           =   3195
   End
   Begin VB.OptionButton optServer 
      Caption         =   "&Server"
      Height          =   255
      Left            =   360
      TabIndex        =   2
      Top             =   720
      Width           =   855
   End
   Begin VB.Frame frRole 
      Caption         =   "Socket Type"
      Height          =   975
      Left            =   180
      TabIndex        =   0
      Top             =   120
      Width           =   1335
      Begin VB.OptionButton optClient 
         Caption         =   "&Client"
         Height          =   255
         Left            =   180
         TabIndex        =   1
         Top             =   240
         Width           =   855
      End
   End
   Begin MSWinsockLib.Winsock wsSocket 
      Left            =   480
      Top             =   3480
      _ExtentX        =   741
      _ExtentY        =   741
      _Version        =   393216
   End
   Begin VB.Label Label6 
      Caption         =   "Received Data:"
      Height          =   255
      Left            =   180
      TabIndex        =   19
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Label Label5 
      Caption         =   "Decrypted Msg:"
      Height          =   255
      Left            =   180
      TabIndex        =   13
      Top             =   2520
      Width           =   1215
   End
   Begin VB.Label Label4 
      Caption         =   "Encrypted Msg:"
      Height          =   255
      Left            =   180
      TabIndex        =   11
      Top             =   2100
      Width           =   1215
   End
   Begin VB.Label Label3 
      Caption         =   "&Message:"
      Height          =   255
      Left            =   180
      TabIndex        =   9
      Top             =   1260
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "Server &Port:"
      Height          =   315
      Left            =   1680
      TabIndex        =   5
      Top             =   600
      Width           =   1455
   End
   Begin VB.Label Label1 
      Caption         =   "Server &Name:"
      Height          =   315
      Left            =   1680
      TabIndex        =   3
      Top             =   180
      Width           =   1455
   End
End
Attribute VB_Name = "frmKeys"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_clsCrypto As clsCrypto
Private m_strPublicKey As String
Private m_strSessionKey As String

Private Sub cmdClose_Click()
    '-- If the socket is not closed, close it
    If wsSocket.State <> sckClosed Then wsSocket.Close
    
    '-- Reset the socket connection buttons
    cmdListen.Enabled = True
    cmdClose.Enabled = False
End Sub

Private Sub cmdExit_Click()
    '-- Did we create or receive a session key?
    If m_strSessionKey <> "" Then
    
        '-- If so, then destroy it
        m_clsCrypto.DestroySessionKey
    End If
    
    '-- Close the application
    Unload Me
End Sub

Private Sub cmdGenKeys_Click()
    '-- Perform the initial server portion of the key exchange
    DoServerKeyExchange
End Sub

Private Sub cmdImportPublicKey_Click()
    '-- Perform the client portion of the key exchange
    DoClientKeyExchange
End Sub

Private Sub cmdImportSessionKey_Click()
    '-- Perform the final server portion of the key exchange
    FinishServerKeyExchange
End Sub

Private Sub cmdListen_Click()
    '-- Are we in client or server mode?
    If optClient Then
    
        '-- Client mode, open a connection to the server
        ConnectToServer
    Else
    
        '-- Server mode, start listening for connection requests
        StartListen
    End If
End Sub

Private Sub cmdSendMsg_Click()
    '-- Encrypt and send the message
    SendEncryptedMsg
End Sub

Private Sub Form_Load()
    '-- Create the instance of the crypto class
    Set m_clsCrypto = New clsCrypto
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '-- Destroy the instance of the crypto class
    Set m_clsCrypto = Nothing
End Sub

Private Sub optClient_Click()
    '-- Client mode
    cmdListen.Caption = "Connec&t"
    optServer.Value = False
    Me.Caption = "Public/Private Keys - Client"
End Sub

Private Sub optServer_Click()
    '-- Server mode
    cmdListen.Caption = "&Listen"
    optClient.Value = False
    Me.Caption = "Public/Private Keys - Server"
End Sub

Private Sub StartListen()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 09, 1999
'*
'* Syntax:     StartListen
'*
'* Parameters:  None
'*
'* Purpose: This subroutine checks to see that a number has
'*          been entered in the port text box. If one has, the
'*          socket is configured to use that port, and is placed
'*          in "Listen" mode.
'*************************************************************
    '-- Do we have a valid value for the port to listen on?
    If IsNumeric(txtPort) Then
        
        '-- Yes, don't allow the mode to be changed
        frRole.Enabled = False
        cmdListen.Enabled = False
        
        '-- Set the port on the socket
        wsSocket.LocalPort = CLng(txtPort)
        
        '-- Start the socket listening for connection requests
        wsSocket.Listen
    Else
        
        '-- No port specified, tell the user
        MsgBox "You must specify a port on which to listen."
    End If
End Sub

Private Sub ConnectToServer()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 09, 1999
'*
'* Syntax:     ConnectToServer
'*
'* Parameters:  None
'*
'* Purpose: This subroutine checks to see that a number has
'*          been entered in the port text box, and a server name
'*          has been entered in the server text box. If one has, the
'*          socket is configured to connect to that port and server,
'*          and the "Connect" method is called.
'*************************************************************
    '-- Do we have a server name to connect to?
    If txtServerName <> "" Then
    
        '-- Do we have a valid value for the port to connect to?
        If IsNumeric(txtPort) Then
        
            '-- Yes, don't allow the mode to be changed
            frRole.Enabled = False
            cmdListen.Enabled = False
            
            '-- Tell the socket what server and port to connect to
            wsSocket.RemotePort = CLng(txtPort)
            wsSocket.RemoteHost = txtServerName
            wsSocket.LocalPort = 0
            
            '-- Open the connection
            wsSocket.Connect
        Else
        
            '-- No port specified, tell the user
            MsgBox "You must specify a port to connect."
        End If
    Else
    
        '-- No server specified, tell the user
        MsgBox "You must specify a server name or IP address."
    End If
End Sub

Private Sub wsSocket_Close()
    '-- If the socket is not closed, close it
    If wsSocket.State <> sckClosed Then wsSocket.Close
    
    '-- Reset the socket connection buttons
    cmdListen.Enabled = True
    cmdClose.Enabled = False
End Sub

Private Sub wsSocket_Connect()
    '-- Connection established, set the socket connection buttons.
    cmdListen.Enabled = False
    cmdClose.Enabled = True
End Sub

Private Sub wsSocket_ConnectionRequest(ByVal requestID As Long)
    '-- Close the socket from listen mode
    If wsSocket.State <> sckClosed Then wsSocket.Close
    
    '-- Accept the connection request
    wsSocket.Accept requestID
    
    '-- Connection established, set the socket connection buttons.
    cmdClose.Enabled = True
    
    '-- Perform the initial server portion of the key exchange
    DoServerKeyExchange
End Sub

Private Sub wsSocket_DataArrival(ByVal bytesTotal As Long)
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 09, 1999
'*
'* Event:     wsSocket_DataArrival
'*
'* Description: When data is received, we have to determine
'*              what the data might be, and what we need to
'*              do with it. Since this is implementing a very
'*              raw protocol, we can take a survey of what we
'*              have and have not received or generated to
'*              determine what we need to do with what we've
'*              received. If we have no public key, then we
'*              are the client and are receiving the public
'*              key for the server. If we have no session key
'*              then we must be the server receiving the client
'*              generated session key that has been encrypted
'*              using our public key. Otherwise, this is message
'*              data that just needs to be decrypted and displayed.
'*************************************************************
    Dim strData As String
    
    '-- Retrieve the data that has arrived
    wsSocket.GetData strData
    
    '-- Show it to the user
    txtRecvdData.Text = strData
    
    '-- Do we have a public key yet?
    If m_strPublicKey = "" Then
    
        '-- No, then this must be the public key of the
        '-- server that we are receiving
        m_strPublicKey = strData
        
        '-- Perform the client portion of the key exchange
        DoClientKeyExchange
        cmdGenKeys.Enabled = False
    Else
        '-- Do we have a session key yet?
        If m_strSessionKey = "" Then
            
            '-- No, then this must be the session key from the
            '-- client that we are receiving
            m_strSessionKey = strData
            
            '-- Perform the final server portion of the key exchange
            FinishServerKeyExchange
        Else
        
            '-- All keys have been exchanged, this is message data
            '-- that we are receiving
            txtEncryptMsg.Text = strData
            
            '-- Perform the message decryption
            ReceiveEncryptedMsg
        End If
    End If
End Sub

Private Sub wsSocket_Error(ByVal Number As Integer, Description As String, ByVal Scode As Long, ByVal Source As String, ByVal HelpFile As String, ByVal HelpContext As Long, CancelDisplay As Boolean)
    '-- Inform the user of the error
    MsgBox "WinSock Error: " + Str(Number) + " - " + Description
End Sub

Private Sub DoServerKeyExchange()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 09, 1999
'*
'* Syntax:     DoServerKeyExchange
'*
'* Parameters:  None
'*
'* Purpose: The initial server portion of the key exchange
'*          consists of retrieving or creating a Public/Private
'*          key pair for the server. The public key is exported
'*          for sending to the client. Finally, the public key
'*          is sent to the client.
'*************************************************************
    '-- Generate or get the public/private key pair
    If Not m_clsCrypto.GetExchangeKeypair Then _
        Exit Sub
        
    '-- Export the public key
    If Not m_clsCrypto.ExportPublicKey Then _
        Exit Sub
    
    '-- Send the public key to the client
    m_strPublicKey = m_clsCrypto.ExportKey
    If wsSocket.State = sckConnected Then
        wsSocket.SendData m_strPublicKey
    Else
        cmdImportPublicKey.Enabled = True
    End If
    cmdGenKeys.Enabled = False
End Sub

Private Sub DoClientKeyExchange()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 09, 1999
'*
'* Syntax:     DoClientKeyExchange
'*
'* Parameters:  None
'*
'* Purpose: The client portion of the key exchange starts by
'*          importing the server's public key. Next, a session
'*          key is generated, encrypted using the server's
'*          public key (ensuring that it can only be decrypted
'*          with the server's private key), and exported and
'*          sent to the server.
'*************************************************************
    '-- Copy the public key to the Crypto object
    m_clsCrypto.ImportKey = m_strPublicKey
    
    '-- Import the server's public key
    If Not m_clsCrypto.ImportPublicKey Then _
        Exit Sub
    
    '-- Create and export a session key.
    '--- The session key is encrypted using the
    '--- server's public key during the export.
    '--- This ensures that only the server can
    '--- import and use this session key using
    '--- it's private key.
    If Not m_clsCrypto.CreateAndExportSessionKey Then _
        Exit Sub
    
    '-- Send the session key to the client
    m_strSessionKey = m_clsCrypto.SessionKey
    If wsSocket.State = sckConnected Then
        wsSocket.SendData m_strSessionKey
        cmdSendMsg.Enabled = True
    Else
        cmdImportSessionKey.Enabled = True
    End If
    cmdImportPublicKey.Enabled = False
End Sub

Private Sub FinishServerKeyExchange()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 09, 1999
'*
'* Syntax:     FinishServerKeyExchange
'*
'* Parameters:  None
'*
'* Purpose: The server completes the key exchange by importing
'*          and decrypting the session key. Once this is done,
'*          both applications are ready to start sending messages
'*          to each other.
'*************************************************************
    '-- Copy the session key to the Crypto object
    m_clsCrypto.SessionKey = m_strSessionKey
    
    '-- Import and decrypt the session key
    If m_clsCrypto.ImportSessionKey Then
    
        '-- We are now ready to send messages back and forth
        cmdSendMsg.Enabled = True
        cmdImportSessionKey.Enabled = False
    End If
End Sub

Private Sub ReceiveEncryptedMsg()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 09, 1999
'*
'* Syntax:     ReceiveEncryptedMsg
'*
'* Parameters:  None
'*
'* Purpose: When an encrypted message is received, it is
'*          decrypted using the session key.
'*************************************************************
    '-- Copy the encrypted message to the Crypto object
    m_clsCrypto.InBuffer = txtEncryptMsg.Text
    
    '-- Decrypt the message using the session key
    If m_clsCrypto.DecryptMessageData Then
    
        '-- Display the decrypted message
        txtDecryptMsg.Text = m_clsCrypto.OutBuffer
    End If
End Sub

Private Sub SendEncryptedMsg()
'*************************************************************
'* Written By: Davis Chapman
'* Date:       September 09, 1999
'*
'* Syntax:     SendEncryptedMsg
'*
'* Parameters:  None
'*
'* Purpose: When sending a message, we need to encrypt it using
'*          the session key. Once the message has been encrypted,
'*          we can send it to the other application.
'*************************************************************
    '-- Copy the message to the Crypto object
    m_clsCrypto.InBuffer = txtMessage.Text
    
    '-- Encrypt the message using the session key
    If m_clsCrypto.EncryptMessageData Then
    
        '-- Display the encrypted message
        txtEncryptMsg.Text = m_clsCrypto.OutBuffer
        
        '-- Are we connected to another application?
        If wsSocket.State = sckConnected Then
        
            '-- Yes, so send the encrypted message
            wsSocket.SendData txtEncryptMsg.Text
        Else
        
            '-- No, Decrypt the message and display
            '-- the results
            ReceiveEncryptedMsg
        End If
    End If
End Sub
