VERSION 5.00
Begin VB.Form frmRDSClient 
   Caption         =   "RDS Client"
   ClientHeight    =   2520
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5970
   LinkTopic       =   "Form1"
   ScaleHeight     =   2520
   ScaleWidth      =   5970
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton cmdConnect 
      Caption         =   "&Connect"
      Height          =   375
      Left            =   4320
      TabIndex        =   12
      Top             =   120
      Width           =   1575
   End
   Begin VB.CommandButton cmdClose 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   4320
      TabIndex        =   11
      Top             =   2040
      Width           =   1575
   End
   Begin VB.CommandButton cmdSendNumber 
      Caption         =   "Send &Number"
      Height          =   375
      Left            =   4320
      TabIndex        =   10
      Top             =   1560
      Width           =   1575
   End
   Begin VB.CommandButton cmdCompareStrings 
      Caption         =   "Compare &Strings"
      Height          =   375
      Left            =   4320
      TabIndex        =   9
      Top             =   1080
      Width           =   1575
   End
   Begin VB.CommandButton cmdGetRecordset 
      Caption         =   "Get &Recordset"
      Height          =   375
      Left            =   4320
      TabIndex        =   8
      Top             =   600
      Width           =   1575
   End
   Begin VB.TextBox txtNumber 
      Height          =   405
      Left            =   1560
      TabIndex        =   7
      Top             =   1560
      Width           =   2655
   End
   Begin VB.TextBox txtRow2Name 
      Height          =   405
      Left            =   1560
      TabIndex        =   5
      Top             =   1080
      Width           =   2655
   End
   Begin VB.TextBox txtRow1Name 
      Height          =   405
      Left            =   1560
      TabIndex        =   3
      Top             =   600
      Width           =   2655
   End
   Begin VB.TextBox txtServer 
      Height          =   405
      Left            =   1560
      TabIndex        =   1
      Top             =   120
      Width           =   2655
   End
   Begin VB.Label Label4 
      Alignment       =   1  'Right Justify
      Caption         =   "Number:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   1560
      Width           =   1335
   End
   Begin VB.Label Label3 
      Alignment       =   1  'Right Justify
      Caption         =   "Row 2 Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   1080
      Width           =   1335
   End
   Begin VB.Label Label2 
      Alignment       =   1  'Right Justify
      Caption         =   "Row 1 Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1335
   End
   Begin VB.Label Label1 
      Alignment       =   1  'Right Justify
      Caption         =   "Server:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
End
Attribute VB_Name = "frmRDSClient"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'--- Define the default servers, objects, domains, etc.
Const m_def_Server = "http://localhost"
Const m_def_Obj = "ExampleServer.clsServer"

'--- Declare the RDS dataspace object
Private m_ds As New RDS.DataSpace
'--- Declare the COM object to be created on the server
Private m_rs As Object

Private Sub cmdClose_Click()
    '--- Have we created a COM object on the server?
    If Not (m_rs Is Nothing) Then
        '--- Yes, destroy it.
        Set m_rs = Nothing
    End If
    '--- Close the application
    Unload Me
End Sub

Private Sub cmdCompareStrings_Click()
    Dim bRtnValue As Boolean
On Error GoTo cmdCompareStrings_Click_Err

    '--- Do we have values to send to the server?
    If (txtRow1Name = "") Or (txtRow2Name = "") Then
        '--- No, tell the user to fill in the values
        MsgBox "You need to provide two row names to compare."
        '--- Exit the sub
        Exit Sub
    End If
    
    '--- Compare the two string values
    bRtnValue = m_rs.GetBoolean(txtRow1Name.Text, txtRow2Name.Text)
    '--- Do they match?
    If bRtnValue Then
        '--- Yes, tell the user
        MsgBox "The two row names match."
    Else
        '--- No, tell the user
        MsgBox "The two row names do not match."
    End If
    '--- Exit the sub
    Exit Sub

cmdCompareStrings_Click_Err:
    '--- Report the error that occurred
    MsgBox "Error : " + CStr(Err.Number) + " - " + Err.Description
End Sub

Private Sub cmdConnect_Click()
On Error GoTo cmdConnect_Click_Err

    '--- Create the object on the server
    Set m_rs = m_ds.CreateObject(m_def_Obj, txtServer)
    '--- Exit the sub
    Exit Sub

cmdConnect_Click_Err:
    '--- Report the error that occurred
    MsgBox "Error : " + CStr(Err.Number) + " - " + Err.Description
End Sub

Private Sub cmdGetRecordset_Click()
    Dim ieUserObj As Object
    Dim strMsg As String
On Error GoTo cmdGetRecordset_Click_Err

    '--- Do we have at least one row name?
    If (txtRow1Name = "") Then
        '--- No, tell the user to fill in a value
        MsgBox "You need to supply at least 1 row name."
        '--- Exit the sub
        Exit Sub
    End If
    '--- Do we have two row names?
    If (txtRow2Name = "") Then
        '--- No, only pass the first row name
        Set ieUserObj = m_rs.GetRecordset(txtRow1Name.Text)
    Else
        '--- Yes, pass both row names
        Set ieUserObj = m_rs.GetRecordset(txtRow1Name.Text, txtRow2Name.Text)
    End If
    '--- Did we get something back?
    If Not (ieUserObj Is Nothing) Then
        '--- Yes we did
        With ieUserObj
            '--- Are there any rows in the recordset?
            If .recordcount > 0 Then
                '--- Yes, move to the first row
                .movefirst
                '--- Loop until the end of the recordset
                While Not .EOF
                    '--- Build a message listing the row values
                    strMsg = "Row Values:" + vbCrLf + _
                        "RowName = " + .fields("RowName") + vbCrLf + _
                        "RowValue = " + CStr(.fields("RowValue")) + vbCrLf + _
                        "RowTime = " + CStr(.fields("RowTime"))
                    '--- Display the values to the user
                    MsgBox strMsg
                    '--- Move to the next row
                    .movenext
                Wend
            End If
        End With
        '--- Destroy the recordset
        Set ieUserObj = Nothing
    End If
    '--- Exit the sub
    Exit Sub

cmdGetRecordset_Click_Err:
    '--- Report the error that occurred
    MsgBox "Error : " + CStr(Err.Number) + " - " + Err.Description
End Sub

Private Sub cmdSendNumber_Click()
    Dim strRtn As String
On Error GoTo cmdSendNumber_Click_Err

    '--- Do we have a numeric value?
    If Not IsNumeric(txtNumber) And (txtNumber <> "") Then Exit Sub
    '--- Do we have a value?
    If (txtNumber <> "") Then
        '--- Yes, convert it to a number and pass it to the server
        strRtn = m_rs.GetString(CInt(txtNumber))
    Else
        '--- No, pass nothing to the server
        strRtn = m_rs.GetString
    End If
    '--- Display the returned message
    MsgBox strRtn
    '--- Exit the sub
    Exit Sub

cmdSendNumber_Click_Err:
    '--- Report the error that occurred
    MsgBox "Error : " + CStr(Err.Number) + " - " + Err.Description
End Sub

Private Sub Form_Load()
    '--- Initialize the server name
    txtServer = m_def_Server
End Sub
